
{
  [3;33m-----------------------------------------------------------------------
  -									  -
  -  SaveKick2File  -  Version 1.1,	   (C)1992  by  Bernd Knnen	  -
  -							Neuringe 75	  -
  -   This programm is Freeware,			44777 Twist	  -
  -   coded in 03.1991 in PCQ-Pascal(1.2b).				  -
  -									  -
  -   Usage : SaveKick2file  filename					  -
  -									  -
  -----------------------------------------------------------------------[0;31m
}

Program SaveKick;

{$I "include:libraries/dos.i"	   }
{$I "include:Utils/parameters.i"   }
{$I "include:exec/exec.i"	   }
{$I "include:exec/execbase.i"	   }
{$I "include:Utils/stringlib.i"    }


CONST
	Kick256 : Integer = 256*1024;		{ 512 bzw. 256 K }
	Kick512 : Integer = 512*1024;
	exec	: Integer = $0004;		{ in $4 ist Ptr auf Execbase }

TYPE		
	adrptr = ^Address;	{ um nachher an den execbaseptr zu kommen }

VAR
	KickMem		: Address;
	KickSize	: Integer;
	MyHandle	: FileHandle;
	myfile		: String;

	myexecbaseptr	: execbaseptr;


{ [2;32m**** Sorgt fr ein sauberes Verlassen des Programms, egal wo man  ****
  **** aussteigt :						    ****[0;31m }

PROCEDURE cleanexit(why : String ; rtcode : Integer);
BEGIN
	{ [0;32m## Ausgabe ins CLI, warum das Program verlassen ##[0;31m }
	{ [0;32m## werden mute, inkl.Returncode f. Batchfiles  ##[0;31m }

	IF MyHandle<>NIL THEN  DOSClose(MyHandle);
	IF why<>NIL THEN writeln(why);
	exit(rtcode);
END;





{ [3;32m**************  Hier nun endlich die Hauptschleife  **************[0;31m }


BEGIN

  writeln("[3;33m SaveKick2File V1.1, (C)1992 B.Knnen\n[0;31m");

  myfile:=AllocString(80);	{ [0;32mBuffer fr 79 chars holen[0;31m }

  GetParam(1,myfile);		{ [0;32mCLI-Argument in Buffer kopieren[0;31m }

  IF strlen(myfile)=0 THEN	{ [0;32mWenn kein CLI-Arg., dann nachfragen [0;31m} 
  BEGIN
    write("Save actual Kickstart 2 file named : ");
    readln(myfile);
    IF strlen(myfile)=0 THEN cleanexit("No filename !",10);
  END;

  myexecbaseptr:=Address(adrptr(exec)^);	{ [0;32mExecbasePtr holen[0;31m }

  IF myexecbaseptr^.LibNode.lib_Version<37 then	{ [0;32mVersion vergleichen[0;31m }
  begin
	writeln("Saving 256K - Kickstart...");
	KickMem:=Address($fc0000);		{ [0;32mversion<37 Then Kick1.3 or lower[0;31m }
	Kicksize:=Kick256;
  end else begin
	writeln("Saving 512K - Kickstart...");	{ [0;32m>=37 -> 2.0 or higher Kickstart[0;31m }
	KickMem:=Address($f80000);
	Kicksize:=Kick512;
  end;

  { [0;32mOpen file and test if ok ...[0;31m }
  MyHandle:=DOSOpen(myfile,MODE_NEWFILE);
  IF MyHandle=NIL THEN cleanexit("Can`t open output-file.",5);

  { [0;32mWrite Kickstart 2 File[0;31m }
  IF DOSWrite(MyHandle,KickMem,KickSize)<>KickSize
    THEN cleanexit("Error writing Kickstart.",5);


  Delay(50);				{ [0;32meine taktvolle Sekunden ......[0;31m }
  cleanexit(NIL,0);			{ [0;32mbye bye baby ....[0;31m }
END.
